using Bp.Sync.BackEnd.Infrastructure.ElasticDbContext;
using Bp.Sync.Domain.Elastics.FcBusinesses;
using Bp.Sync.Dto.Results;
using Bp.Sync.Dto.SmartTable;
using Microsoft.Extensions.Options;
using Nest;
using System;
using System.Collections.Generic;
using System.Threading.Tasks;

namespace Bp.Sync.BackEnd.Infrastructure.Repositories.FcBusinesses
{
    public interface IInboundStatisticRepository
    {
        Task<BaseResult> Add(InboundStatisticElastic InboundStatistic);
        Task<BaseResult> AddManyAsync(IEnumerable<InboundStatisticElastic> InboundStatistics);
        Task<BulkResponse> DeleteInboundStatistics(IEnumerable<InboundStatisticElastic> InboundStatistics);
        Task<DeleteByQueryResponse> DeleteInboundStatisticsByQuery(IEnumerable<long> ids);
        Task<SmartTableResult<InboundStatisticElastic>> SearchForExcel(BoolQueryDescriptor<InboundStatisticElastic> query);

    }
    public class InboundStatisticRepository : IInboundStatisticRepository
    {
        private readonly ElasticIndex<InboundStatisticElastic> _dbContext;

        public InboundStatisticRepository(IOptions<ElasticConnectionSettings> settings)
        {
            _dbContext = new ElasticIndex<InboundStatisticElastic>(settings.Value.ClusterUrl, "fcbusinessinboundstatistic");
        }

        #region  search

        public async Task<SmartTableResult<InboundStatisticElastic>> SearchForExcel(BoolQueryDescriptor<InboundStatisticElastic> query)
        {
            return await _dbContext.Search(query);
        }

        #endregion

        #region Add order

        public async Task<BaseResult> Add(InboundStatisticElastic InboundStatistic)
        {
            var result = new BaseResult() { Result = Dto.Results.Result.Success };
            var rs = await _dbContext.Insert(InboundStatistic);
            if (rs.IsValid)
            {
                result.Result = Dto.Results.Result.Success;
            }
            else
            {
                result.Result = Dto.Results.Result.SystemError;
                result.Message = "Không tạo được bản ghi";
            }
            return result;
        }
        public async Task<BaseResult> AddManyAsync(IEnumerable<InboundStatisticElastic> InboundStatistics)
        {
            var result = new BaseResult { Result = Dto.Results.Result.Success };
            try
            {
                var rs = await _dbContext.InsertMany(InboundStatistics);
                if (rs.IsValid) return result;
                else
                {
                    result.Result = Dto.Results.Result.Failed;
                    result.Message = rs.Errors.ToString();
                    return result;
                }
            }
            catch (Exception exx)
            {
                result.Result = Dto.Results.Result.Failed;
                result.Message = exx.Message.ToString();
                return result;
            }
        }

        public async Task<BulkResponse> DeleteInboundStatistics(IEnumerable<InboundStatisticElastic> InboundStatistics)
        {
            return await _dbContext.DeleteMany(InboundStatistics);
        }

        public async Task<DeleteByQueryResponse> DeleteInboundStatisticsByQuery(IEnumerable<long> ids)
        {
            return await _dbContext.DeleteByIds(ids);
        }

        #endregion
    }
}
